part of '../../../store_management.dart';

class ProductModel extends NameModel<int> {
  static const String typeIdTag = "typeId";
  final int typeId;
  static const String descriptionTag = "description";
  final String? description;
  static const String secondNameTag = "secondName";
  final String? secondName;
  static const String barcodeTag = "barcode";
  final String? barcode;
  static const String imagesTag = "images";
  final List<String>? images;
  static const String hasExpireDateTag = "hasExpireDate";
  final bool hasExpireDate;
  static const String isServiceTag = "isService";
  final bool isService;

  const ProductModel({
    super.id = 0,
    required super.name,
    super.status,
    required this.typeId,
    this.description,
    this.barcode,
    this.images,
    this.secondName,
    this.isService = false,
    this.hasExpireDate = false,
  });

  ProductModel.fromMap(super.map)
      : description = map.getString(descriptionTag),
        typeId = map.getInt(typeIdTag)!,
        barcode = map.getString(barcodeTag),
        images = map.getList(imagesTag)?.cast<String>(),
        secondName = map.getString(secondNameTag),
        isService = map.getBool(isServiceTag)!,
        hasExpireDate = map.getBool(hasExpireDateTag)!,
        super.fromMap();

  @override
  Map<String, dynamic> toMap() => {
        ...super.toMap(),
        descriptionTag: description,
        typeIdTag: typeId,
        barcodeTag: barcode,
        imagesTag: images,
        secondNameTag: secondName,
        isServiceTag: isService,
        hasExpireDateTag: hasExpireDate,
      };

  static const List<ProductModel> temp = [];
}
