part of '../../../store_management.dart';

class ProductMeasureModel extends Model {
  static const String productIdTag = "productId";
  final int productId;
  static const String measureUintIdTag = "measureUintId";
  final int measureUintId;
  static const String currencyIdTag = "currencyId";
  final int currencyId;
  static const String priceTag = "price";
  final double price;
  static const String statusTag = "status";
  final bool status;
  static const String partsTag = "parts";
  final int? parts;

  const ProductMeasureModel({
    required this.productId,
    required this.measureUintId,
    required this.currencyId,
    required this.price,
    this.status = true,
    this.parts,
  });

  ProductMeasureModel.fromMap(super.map)
      : productId = map.getInt(productIdTag)!,
        measureUintId = map.getInt(measureUintIdTag)!,
        currencyId = map.getInt(currencyIdTag)!,
        price = map.getDouble(priceTag)!,
        status = map.getBool(statusTag)!,
        parts = map.getInt(partsTag),
        super.fromMap();

  @override
  List<Object?> get props => [productId, measureUintId, currencyId];

  @override
  Map<String, dynamic> toMap() => {
        productIdTag: productId,
        measureUintIdTag: measureUintId,
        currencyIdTag: currencyId,
        priceTag: price,
        statusTag: status,
        partsTag: parts,
      };
}
