part of '../../../store_management.dart';

class ProductStorageModel extends Model {
  static const String productIdTag = "productId";
  final int productId;
  static const String measureUintIdTag = "measureUintId";
  final int measureUintId;
  static const String currencyIdTag = "currencyId";
  final int currencyId;
  static const String storeIdTag = "storeId";
  final int storeId;
  static const String buyPriceTag = "buyPrice";
  final double buyPrice;
  static const String expiredAtTag = "expiredAt";
  final DateTime? expiredAt;
  static const String countTag = "count";
  final int count;

  ProductStorageModel.fromMap(super.map)
      : productId = map.getInt(productIdTag)!,
        measureUintId = map.getInt(measureUintIdTag)!,
        currencyId = map.getInt(currencyIdTag)!,
        storeId = map.getInt(storeIdTag)!,
        buyPrice = map.getDouble(buyPriceTag)!,
        count = map.getInt(countTag)!,
        expiredAt = map.getDateTime(expiredAtTag)!,
        super.fromMap();

  @override
  List<Object?> get props =>
      [productId, measureUintId, currencyId, storeId, buyPrice, expiredAt];

  @override
  Map<String, dynamic> toMap() => {
        productIdTag: productId,
        measureUintIdTag: measureUintId,
        currencyIdTag: currencyId,
        storeIdTag: storeId,
        buyPriceTag: buyPrice,
        countTag: count,
        expiredAtTag: expiredAt?.toIso8601String(),
      };
}
